AC_DEFUN(DV_REQUIRE_XMLWRAPP,
[
DV_REQUIRE_CFUNC(xmlBufferCat,xml2)
DV_APPEND_UNIQ("-lxml2", CXXLTLIBS)
DV_REQUIRE_CFUNC(xsltDocumentFunction,xslt)
DV_APPEND_UNIQ("-lxslt", CXXLTLIBS)
DV_APPEND_UNIQ("-lexslt", CXXLTLIBS)
DV_REQUIRE_LIB([xmlwrapp/init.h], [xml::init i;], xmlwrapp,
  [${prefix}/lib /usr/local/lib /usr/lib ${ac_default_prefix}/lib ],
  [${prefix}/include /usr/local/include /usr/include ${ac_default_prefix}/include ] )
DV_APPEND_UNIQ("-lxsltwrapp", CXXLTLIBS)
])

@AC_DEFUN(DV_HAVE_FORWARD_ITERATOR,[
AC_MSG_CHECKING([std::iterator exists])
DV_HAVE_ITERATOR=""

AC_LANG_PUSH(C++)
if test -z "$DV_HAVE_ITERATOR"; then
  AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[#include <iterator>]], [[
    typedef std::iterator<std::forward_iterator_tag, int> it;
    ]])],[DV_HAVE_ITERATOR="iterator"],[])
fi

if test -z "$DV_HAVE_ITERATOR"; then
  AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[#include <iterator>]], [[
    typedef std::forward_iterator<int, ptrdiff_t> it;
    ]])],[DV_HAVE_ITERATOR="forward_iterator"],[])
fi
AC_LANG_POP(C++)

if test -n "$DV_HAVE_ITERATOR"; then
  AC_MSG_RESULT($DV_HAVE_ITERATOR)
fi

if test -z "$DV_HAVE_ITERATOR"; then
  AC_MSG_ERROR([neiter iterator<2> nor forward_iterator<2> ])
fi

if test "$DV_HAVE_ITERATOR" = forward_iterator; then
  FORWARD_ITERATOR="std::forward_iterator<T, ptrdiff_t>"
  AC_SUBST(FORWARD_ITERATOR)
elif test "$DV_HAVE_ITERATOR" = iterator; then
  FORWARD_ITERATOR="std::iterator<std::forward_iterator_tag, T >"
  AC_SUBST(FORWARD_ITERATOR)
else
  AC_MSG_ERROR([neiter iterator<2> nor input_iterator<2> available])
fi

])
