#ifndef DVXML_NOCONST_H
#define DVXML_NOCONST_H
// $Id: noconst.h,v 1.3 2003/06/01 08:23:24 dvermeir Exp $

namespace Dv {
namespace Xml {

/** Utility template: noconst<T>::mutable_type is T if T is not
 * "const" and X if T is "const X".
 */
template<typename T>
struct noconst {
  /** Mutable_type is T if T is not "const" and X if T is "const X".  */
  typedef T mutable_type;
};

/** Utility template: noconst<T>::mutable_type is T if T is not
 * "const" and X if T is "const X".
 */
template<typename T>
struct noconst<const T> {
  /** Mutable_type is T if T is not "const" and X if T is "const X".  */
  typedef T mutable_type;
};

/** Utility template: noconst<T>::mutable_type is T if T is not
 * "const" and X if T is "const X".
 */
template<typename T>
struct noconst<T*> {
  /** Mutable_type is T if T is not "const" and X if T is "const X".  */
  typedef void mutable_type;
};

}}
#endif
