// $Id: test-charset-node.C,v 1.1 2003/10/23 08:40:51 dvermeir Exp $

// Test iconv functions together with XML node content.
#include <iostream>
#include <stdexcept>
#include <string>

#include "xml.h"

int
main(int, char**) {
try {
  const char* buf = "De Gussem, Marc";
  const std::string iso_s(buf);

  std::string utf_s(Dv::Xml::iso2utf8(buf));

  Dv::Xml::Node node("naam", utf_s);

  std::cout << iso_s << " -> " << utf_s << std::endl;
  std::cout << node << std::endl;

  return 0;
  }
catch (std::exception& e) {
  std::cerr << "exception: " << e.what() << std::endl;
  return 1;
  }
}
