// $Id: test-charset.C,v 1.1 2003/05/15 08:25:09 dvermeir Exp $

// Test iconv functions.
#include <iostream>
#include <stdexcept>
#include <string>

#include "xml.h"

int
main(int, char**) {
try {
  const char* buf = "De Gussem, Marc";
  const std::string iso_s(buf);

  std::string utf_s(Dv::Xml::iso2utf8(buf));

  std::cout << iso_s << " -> " << utf_s << std::endl;

  if ( Dv::Xml::iconv("ISO-8859-1", "UTF8", utf_s) != iso_s )
    throw std::runtime_error("unexpected inequality");

  try {
    Dv::Xml::iconv("ISO-8859-1", "UTF8", iso_s);

    std::cout << "Error: expected exception not thrown" << std::endl;
    return 1;
    }
  catch (std::exception& e) {
    std::cout << "expected exception: " << e.what() << std::endl;
    }
  return 0;
  }
catch (std::exception& e) {
  std::cerr << "exception: " << e.what() << std::endl;
  return 1;
  }
}
