// $Id: test-conversion-attribute.C,v 1.1 2003/07/12 13:21:41 dvermeir Exp $

// Test Dv::Xml::Node automatic conversions functions.

#include "xml.h"
#include "node.h"

Dv::Xml::Node mknode() {
Dv::Xml::Node n("mknode");
n>>"mknode-child">>"mknode-grandchild";
n>>"mknode-other";
n>>"mknode-child">>"mknode-grandchild";
return n;
}

int
main(int, char**) {
try {
  Dv::Xml::Node n("root");
  n>>"child">>"grandchild";
  n>>"other";
  n>>"child">>"grandchild";

  n["name"] = "value";
  std::string s = n("name");
  if (s != "value")
    throw std::runtime_error(s + ": instead of expected \"value\"");

  n["number"] = 2;
  int k = n["number"];
  if (k != 2)
    throw std::runtime_error(Dv::Util::tostring(k) + ": instead of expected \"2\"");

  std::cout << n << std::endl;
  return 0;

  }
catch (std::exception& e) {
  std::cerr << "exception: " << e.what() << std::endl;
  return 1;
  }
}
