// $Id: test-conversion-content.C,v 1.2 2003/07/13 11:45:05 dvermeir Exp $

// Test Dv::Xml::Node automatic conversions functions.

#include "xml.h"
#include "node.h"

int
main(int, char**) {
try {
  Dv::Xml::Node n("root");
  (n>>"child">>"grandchild">>"age") = 3;
  ((n/"child"/"grandchild")>>"name") = "fred";
  std::cout << n << std::endl;

  int age = (n/"child"/"grandchild"/"age");
  if (age != 3)
    throw std::runtime_error(Dv::Util::tostring(age) + ": but expected 3");

  std::string name = (n/"child"/"grandchild"/"name");
  if (name != "fred")
    throw std::runtime_error(name + ": but expected \"fred\"");

  std::string nm;
  nm = (n/"child"/"grandchild"/"name").str();
  if (name != "fred")
    throw std::runtime_error(name + ": but expected \"fred\"");

  return 0;

  }
catch (std::exception& e) {
  std::cerr << "exception: " << e.what() << std::endl;
  return 1;
  }
}
