// $Id: test-doc-1.C,v 1.3 2003/08/08 11:24:35 dvermeir Exp $

// Test Dv::Xml::Document functions.

#include "xml.h"

int
main(int, char**) {
try {
  {
  // 1. Create default document.
  // std::cerr << "1. Create default document." << std::endl;
  Dv::Xml::Document doc;
  // std::cerr << doc << std::endl;

  if (doc.root().name() != "blank")
    throw std::runtime_error("Name of root of default doc not blank");
  }

  {
  // 2. Create document with root.
  // <root>
  //   <child>
  //     <grandchild name="Manon"/>
  //   <child>
  // <root/>

  // std::cerr << "2. Create document with root." << std::endl;
  Dv::Xml::Node n("root");
  (n>>"child">>"grandchild")["name"]="Manon";
  // std::cerr << "n=" << n << std::endl;
  Dv::Xml::Document doc(n);
  // std::cerr << doc << std::endl;

  if ( (doc.root()/"child"/"grandchild")("name") != "Manon")
    throw std::runtime_error("Test 2 failed");
  }

  {
  // 3. Create default document, set root later.
  // <root>
  //   <child>
  //     <grandchild name="Manon"/>
  //   <child>
  // <root/>
  // std::cerr << "3. Create default document, set root later." << std::endl;
  Dv::Xml::Node n("root");
  (n>>"child">>"grandchild")["name"]="Manon";

  Dv::Xml::Document doc;
  doc = n;
  // std::cerr << doc << std::endl;

  if ( (doc.root()/"child"/"grandchild")("name") != "Manon")
    throw std::runtime_error("Test 3 failed");
  }

  {
  // 4. Create default document, set root to bad node.
  // <root>
  //   <child>
  //     <grandchild name="Manon"/>
  //   <child>
  // <root/>
  // std::cerr << "4. Create default document, set root to bad node." << std::endl;
  Dv::Xml::Node n("root");
  (n>>"child">>"grandchild")["name"]="Manon";

  Dv::Xml::Document doc;
  try {
    doc = (n/"fred");
    // std::cerr << "Test 4 failed" << std::endl;
    return 1;
    }
  catch (Dv::Xml::Exception& e) {
    }
  }

  return 0;
  }
catch (std::exception& e) {
  std::cerr << "exception: " << e.what() << std::endl;
  return 1;
  }
}
