// $Id: test-doc-10.C,v 1.1 2003/08/08 11:39:04 dvermeir Exp $


#include "xml.h"

const std::string doc_string(
  "<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"no\"?> \n"
  "<dvlogin-request> \n"
  "<login name=\"fred\" passwd=\"&amp;123&gt;\" ip=\"134.184.65.2\" \n"
  " duration=\"20\" info=\"Fred Flater\"/> \n"
  "</dvlogin-request> \n"
  );

int
main(int, char**) {

try {
  Dv::Xml::Document doc(doc_string.data(), doc_string.size());
  Dv::Xml::Node::Ref r(doc/"login");
  if (r("name") != "fred")
    throw std::runtime_error("failed");

  Dv::Xml::Document doc1("root","value");
  if (doc1.root().str() != "value")
    throw std::runtime_error("failed2");
  if (doc1.root().name() != "root")
    throw std::runtime_error("failed3");

  Dv::Xml::Document doc2("root");
  if (doc2.root().name() != "root")
    throw std::runtime_error("failed4");
  
  return 0;
  }
catch (std::exception& e) {
  std::cerr << "exception: " << e.what() << std::endl;
  return 1;
  }
}
