// $Id: test-doc-2.C,v 1.4 2003/08/08 11:24:35 dvermeir Exp $

// Test Dv::Xml::Document root() function.

#include "xml.h"

int
main(int, char**) {
try {
  {
  Dv::Xml::Node n("root");
  (n>>"child">>"grandchild")["name"]="Manon";
  
  Dv::Xml::Document doc(n);
  // std::cerr << doc << std::endl;

  (doc.root()>>"child">>"grandchild")["name"]="Fred";

  Dv::Xml::Node::Ref c(doc.root()/"child");
  if ( ((++c)/"grandchild")("name") != "Fred" )
    throw std::runtime_error("Test 1 failed");

  // std::cerr << doc << std::endl;

  Dv::Xml::Node m("root2");
  (m>>"child2">>"grandchild2")["name2"]="Manon2";
  doc.root(m);

  if ( (doc.root()/"child2"/"grandchild2")("name2") != "Manon2" )
    throw std::runtime_error("Test 2 failed");

  // std::cerr << doc << std::endl;
  }

  /*
  {
  // 4. Create default document, set root later.
  // <root>
  //   <child>
  //     <grandchild name="Manon"/>
  //   <child>
  // <root/>
  std::cerr << "4. Create default document, set root later." << std::endl;
  Dv::Xml::Node n("root");
  (n>>"child">>"grandchild")["name"]="Manon";

  Dv::Xml::Document doc;
  doc = n;
  std::cerr << doc << std::endl;
  }
  */
  /*
  {
  // 5. Create default document, set root to bad node.
  // <root>
  //   <child>
  //     <grandchild name="Manon"/>
  //   <child>
  // <root/>
  std::cerr << "5. Create default document, set root to bad node." << std::endl;
  Dv::Xml::Node n("root");
  (n>>"child">>"grandchild")["name"]="Manon";

  Dv::Xml::Document doc;
  try {
    doc = (n/"fred");
    return 1;
    }
  catch (Dv::Xml::Exception& e) {
    }
  }
  */

  return 0;
  }
catch (std::exception& e) {
  std::cerr << "exception: " << e.what() << std::endl;
  return 1;
  }
}
