// $Id: test-doc-9.C,v 1.2 2003/08/08 11:24:35 dvermeir Exp $

// Test Dv::Xml::Document::select("a/b/c[fred]")

#include "xml.h"

const std::string doc_string(
  "<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"no\"?> \n"
  "<a> \n"
  "<b1> \n"
  "<cnode attr=\"123\">\n"
  "<junk></junk>"
  "<last>\n\n"
  "value\n"
  "</last>\n\n"
  " </cnode> \n"
  "</b1> \n"
  "</a> \n"
  );

int
main(int, char**) {

try {
  Dv::Xml::Document doc(doc_string.data(), doc_string.size());
  // std::cout << doc << std::endl;
  // Dv::Xml::Node node(doc.select("b1/cnode/last"));
  // std::cout << node << std::endl;
  // std::cout << "|" << node.str() << "|" << std::endl;

  if (doc.select("b1/cnode/last").str() != "value")
    throw std::runtime_error("Error-1");

  try {
    doc.select("b1/cnode/nonexisting/last");
    return 1;
    }
  catch (Dv::Xml::Exception& e) {
    std::cerr << "expected: " << e.what() << std::endl;
    }

  // if (doc.select("b1/cnode").str() != "value")
  //  throw std::runtime_error("Error-1");
  /*
  if (doc.select("a/b1/cnode[attr]") != "123")
    throw std::runtime_error("Error-2");
  */
  return 0;
  }
catch (std::exception& e) {
  std::cerr << "exception: " << e.what() << std::endl;
  return 1;
  }
}
