// $Id: test-node-1.C,v 1.3 2003/06/08 14:37:02 dvermeir Exp $

// Test Dv::Xml::Node functions.

#include "xml.h"
#include "node.h"

int
main(int, char**) {
try {
  // 1. Create
  // <root>
  //   <child>
  //     <grandchild name="Manon"/>
  //   <child>
  // <root/>
  Dv::Xml::Node n("root");
  (n >>"child">>"grandchild")["name"]="Manon";
  // std::cout << n << std::endl;
  // std::cout << "|" << n["name"] << "|" << std::endl;

  Dv::Xml::Node::Ref bad_node(n/"child"/"fred");
  if (bad_node)
    return 1;
    
  Dv::Xml::Node::Ref grandchild( n/"child"/"grandchild");
  if (! grandchild)
    return 1;

  std::string s( grandchild("name") );
  if (s != "Manon")
    return 1;

  if ( grandchild.defined("number") )
    return 1;
  if (! grandchild.defined("name") )
    return 0;

  return 0;
  }
catch (std::exception& e) {
  std::cerr << "exception: " << e.what() << std::endl;
  return 1;
  }
}
