// $Id: test-node-3.C,v 1.5 2003/07/12 13:21:41 dvermeir Exp $

// Test Dv::Xml::Node functions. Test iterator functions.

#include <algorithm>
#include "xml.h"
#include "node.h"

bool
funny(const Dv::Xml::Node::Ref& n) {
return ( n.name() == "child" );
}

int
main(int, char**) {
try {
  // 1. Create
  // <root>
  //   <child>
  //     <grandchild number="1"/>
  //   <child>
  //   .. 
  // <root/>
  static const size_t N_CHILDREN(100);
  Dv::Xml::Node n("root");
  for (size_t i = 0; i<N_CHILDREN; ++i) {
    (n>>"child">>"grandchild")["number"] = i;
    (n>>"cat")["number"] = i;
    }

  size_t c( std::count_if(n/"child", n.end(), funny) ); 
  if (c != N_CHILDREN)
    return 1;
  return 0;
  }
catch (std::exception& e) {
  std::cerr << "exception: " << e.what() << std::endl;
  return 1;
  }
}
