// $Id: test-node.C,v 1.8 2003/07/12 13:21:41 dvermeir Exp $

// Test Dv::Xml::Node functions.

#include "xml.h"
#include "node.h"

Dv::Xml::Node mknode() {
Dv::Xml::Node n("mknode");
n>>"mknode-child">>"mknode-grandchild";
n>>"mknode-other";
n>>"mknode-child">>"mknode-grandchild";
return n;
}

int
main(int, char**) {
try {
  std::cout << "# Creating Dv::Xml::Node.. " << std::endl;
  Dv::Xml::Node n("root");

  std::cout << n << std::endl;

  std::cout << "# Adding child to Dv::Xml::Node.. " << std::endl;
  n>>"child">>"grandchild";
  n>>"other";
  n>>"child">>"grandchild";
  std::cout << n << std::endl;

  std::cout << "# Setting an attribute of a Dv::Xml::Node.. " << std::endl;
  n["name"] = "value";
  std::cout << n << std::endl;

  std::cout << "# Getting an attribute of a Dv::Xml::Node.. " << std::endl;

  std::cout << n["name"] << std::endl;
  std::cout << n("name") << std::endl;

  std::cout << "# Finding first child with name of Dv::Xml::Node.. " << std::endl;
  (n/"child")["number"] = 1;
  (n/"child"/"grandchild")["number"] = 1;
  // std::cout << (n/"child") << std::endl;
  std::cout << n << std::endl;

  std::cout << "# Finding next child with name of Dv::Xml::Node.. " << std::endl;
  Dv::Xml::Node::Ref c(n/"child");
  ++c;
  c["number"] = 2;
  std::cout << n << std::endl;
  int k(c["number"]);
  std::cout << "CONVERSION to int: " << k << std::endl;

  std::cout << "# Appending separately made Dv::Xml::Node.. " << std::endl;
  Dv::Xml::Node root("root");
  (n/"other") >> mknode();
  std::cout << n << std::endl;

  std::cout << "# Assigning Dv::Xml::Node.. " << std::endl;
  // (n/"other") = mknode();
  (n/"other").replace(n);
  std::cout << n << std::endl;
  // n = mknode();
  // std::cout << n << std::endl;

  std::cout << "# Getting/setting content.. " << std::endl;
  (n/"child") = "Some text";
  // If we would have written the following line as
  //   std::string content(n/"child"), 
  // an ambiguity would have resulted 
  std::string content = (n/"child"); // automatic conversion to
  if (content != "Some text")
    throw std::runtime_error(content + ": not equal to 'Some text'");
  // std::string content((n/"root").str());
  std::cout << n << std::endl;

  std::string k2 = (++(n/"child"))("number");
  std::cout << "number of 2nd child is " << k2 << std::endl;
  return 0;
  }
catch (std::exception& e) {
  std::cerr << "exception: " << e.what() << std::endl;
  return 1;
  }
}
