// $Id: test-tohtml.C,v 1.2 2003/10/21 11:48:00 dvermeir Exp $

#include <iostream>
#include "tohtml.h"
#include <dvxml/node.h>

int
main(int, char**) {
try {
  std::string sin("<a href=\"http://bla.com/xxx.cgi?a=1&b=2\">link</a>");
  std::cout << Dv::Xml::to_html(sin) << std::endl;

  // Check whether we can put strange content in a node.
  std::string bah("three&&&ampersands");
  std::string subnode("subnode");
  Dv::Xml::Node node("testnode");
  node >> subnode = Dv::Xml::to_html(bah);
  std::string s((node/subnode).str());
  if (s != bah)
    throw std::runtime_error(s + ": problem putting \"three&&&ampersands\" in node");
  std::cout << node << std::endl;
  std::cout << "s = \"" << s << "\" (as expected)" << std::endl;
  return 0;
  }
catch (std::exception& e) {
  std::cerr << e.what() << std::endl;
  return 1;
  }
}
