// $Id: tohtml.h,v 1.2 2003/09/08 14:14:32 dvermeir Exp $
#include <string>

namespace Dv {
namespace Xml {

/** Convert to html representation. E.g. '&' becomes '&amp;' etc.
 * @param c char to convert
 * @return HTML representation of c
 */
const char* to_html(unsigned char c) throw ();

/** Convert string to html representation. E.g. '&' becomes '&amp;' etc.
 * @param sin string to convert.
 * @param sout string to which result of conversion will be appended.
 * @return reference to @a sout.
 */
std::string& to_html(const std::string& sin, std::string& sout) throw ();

/** Convert string to html representation. E.g. '&' becomes '&amp;' etc.
 * @param sin string to convert.
 * @return converted string
 */
std::string to_html(const std::string& sin) throw ();

}}
